//MQL5 Version  June 21, 2010 Final
//+X================================================================X+
//|                                         VidyaBandsSeries_Cls.mqh |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//+X----------------------------------------------------------------X+
//   CStdDeviation{};  CCMO{};                       | 
//+X----------------------------------------------------------------X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+
//|        VIDYA          |
//+X================================================================X+
class CVidyaBands
 {
public:
  double VidyaBandsSeries(uint begin, //     
                           uint prev_calculated, //       
                           uint rates_total, //       
                           int CMO_period, //    CMO
                           double EMA_period, // EMA  
                           ENUM_MA_METHOD MA_Method, //  
                           int BBLength, //    
                           double deviation, // 
                           double series,  //   ,      bar
                           uint bar,  //  
                           bool set, //   
                           double& DnMovSeries, //        
                           double& MovSeries,  //        
                           double& UpMovSeries  //        
                          ) 
   {
//----+
    //----+       
    MovSeries = m_VIDYA.VIDYASeries(begin, prev_calculated, rates_total, CMO_period, EMA_period, series, bar, set);
  
    //----+   
    double StdDev = m_STD.StdDevSeries(begin+CMO_period+1, prev_calculated, rates_total, BBLength, deviation, series, MovSeries, bar, set);
    DnMovSeries = MovSeries - StdDev;
    UpMovSeries = MovSeries + StdDev;
//----+
    return(StdDev); 
   }
 
  protected:
    //----    CCMO  CStdDeviation
    CCMO           m_VIDYA;
    CStdDeviation  m_STD;
 };
//+X----------------------+ <<< The End >>> +-----------------------X+