//MQL5 Version  June 21, 2010 Final
//+X================================================================X+
//|                                                ROCSeries_Cls.mqh |
//|                                T3 code: Copyright  1998, Tilson |
//|                MQL5 T3Series: Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+ 
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//+X----------------------------------------------------------------X+
//   CMovSeriesTools                                   | 
//+X----------------------------------------------------------------X+ 
#include <MovSeriesTools_Cls.mqh>
//+X================================================================X+
//|               |
//+X================================================================X+
class CROC : public CMovSeriesTools
 {
public: 
   double  ROCSeries(uint begin,//     
                      uint prev_calculated,//       
                      uint rates_total,//       
                      int Length,//  
                      double series,//   ,      bar
                      uint bar,//  
                      bool set //   .
                      );
protected:
   
   double  m_SeriesArray[];
   int     m_Size_, m_count;
 };
//+X================================================================X+
//|                                                  |
//+X================================================================X+    
double CROC::ROCSeries
(
 uint begin,//     
 uint prev_calculated,//       
 uint rates_total,//       
 int Length,//  
 double series,//   ,      bar
 uint bar,//  
 bool set //   
 )
// MomentumSeries(begin, prev_calculated, rates_total, Length, series, bar, set) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  { 
//----+      
   if(BarCheck1(begin,bar,set)) return(EMPTY_VALUE);

//----+   
   int kkk, Length_=Length+1;
   double ROC;
   
//----+    Length  
   LengthCheck(Length);	

//----+    
   if(bar==begin && !SeriesArrayResize(__FUNCTION__, Length_, m_SeriesArray, m_Size_))
      return(EMPTY_VALUE);

//----+      m_SeriesArray
   Recount_ArrayZeroPos(m_count, Length_, prev_calculated, series, bar, m_SeriesArray);

//----+  
   if(BarCheck3(begin, bar, set, Length_)) return(EMPTY_VALUE);

//----+    
   kkk = Recount_ArrayNumber(m_count, Length_, Length);
   ROC = 100 * series / m_SeriesArray[kkk];
//----+
   return(ROC);
  } 
//+X----------------------+ <<< The End >>> +-----------------------X+